Package org.mozilla.javascript.tools.debugger

## Class SwingGui

- java.lang.Object
- - java.awt.Component
  - - java.awt.Container
    - - java.awt.Window
      - - java.awt.Frame
        - - javax.swing.JFrame
          - - org.mozilla.javascript.tools.debugger.SwingGui

- All Implemented Interfaces:
    `java.awt.image.ImageObserver`, `java.awt.MenuContainer`, `java.io.Serializable`, `javax.accessibility.Accessible`, `javax.swing.RootPaneContainer`, `javax.swing.WindowConstants`, `GuiCallback`

      public class SwingGui
      extends javax.swing.JFrame
      implements GuiCallback

  GUI for the Rhino debugger.
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class javax.swing.JFrame

      `javax.swing.JFrame.AccessibleJFrame`

    - ### Nested classes/interfaces inherited from class java.awt.Frame

      `java.awt.Frame.AccessibleAWTFrame`

    - ### Nested classes/interfaces inherited from class java.awt.Window

      `java.awt.Window.AccessibleAWTWindow, java.awt.Window.Type`

    - ### Nested classes/interfaces inherited from class java.awt.Container

      `java.awt.Container.AccessibleAWTContainer`

    - ### Nested classes/interfaces inherited from class java.awt.Component

      `java.awt.Component.AccessibleAWTComponent, java.awt.Component.BaselineResizeBehavior, java.awt.Component.BltBufferStrategy, java.awt.Component.FlipBufferStrategy`

  - ### Field Summary

    - ### Fields inherited from class javax.swing.JFrame

      `accessibleContext, rootPane, rootPaneCheckingEnabled`

    - ### Fields inherited from class java.awt.Frame

      `CROSSHAIR_CURSOR, DEFAULT_CURSOR, E_RESIZE_CURSOR, HAND_CURSOR, ICONIFIED, MAXIMIZED_BOTH, MAXIMIZED_HORIZ, MAXIMIZED_VERT, MOVE_CURSOR, N_RESIZE_CURSOR, NE_RESIZE_CURSOR, NORMAL, NW_RESIZE_CURSOR, S_RESIZE_CURSOR, SE_RESIZE_CURSOR, SW_RESIZE_CURSOR, TEXT_CURSOR, W_RESIZE_CURSOR, WAIT_CURSOR`

    - ### Fields inherited from class java.awt.Component

      `BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

    - ### Fields inherited from interface java.awt.image.ImageObserver

      `ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

    - ### Fields inherited from interface javax.swing.WindowConstants

      `DISPOSE_ON_CLOSE, DO_NOTHING_ON_CLOSE, EXIT_ON_CLOSE, HIDE_ON_CLOSE`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `SwingGui​(Dim dim, java.lang.String title)` | Creates a new SwingGui.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `actionPerformed​(java.awt.event.ActionEvent e)` | Performs an action from the menu or toolbar.
    `protected void` | `createFileWindow​(Dim.SourceInfo sourceInfo, int line)` | Creates and shows a new `FileWindow` for the given source.
    `void` | `dispatchNextGuiEvent()` | Processes the next GUI event.
    `void` | `enterInterrupt​(Dim.StackFrame lastFrame, java.lang.String threadTitle, java.lang.String alertMessage)` | Called when the interrupt loop has been entered.
    `org.mozilla.javascript.tools.debugger.JSInternalConsole` | `getConsole()` | Returns the debugger console component.
    `org.mozilla.javascript.tools.debugger.Menubar` | `getMenubar()` | Returns the Menubar of this debugger frame.
    `boolean` | `isGuiEventThread()` | Returns whether the current thread is the GUI event thread.
    `void` | `setExitAction​(java.lang.Runnable r)` | Sets the `Runnable` that will be run when the "Exit" menu item is chosen.
    `void` | `setVisible​(boolean b)` | Sets the visibility of the debugger GUI.
    `protected void` | `showFileWindow​(java.lang.String sourceUrl, int lineNumber)` | Shows a `FileWindow` for the given source, creating it if it doesn't exist yet.
    `protected boolean` | `updateFileWindow​(Dim.SourceInfo sourceInfo)` | Update the source text for `sourceInfo`.
    `void` | `updateSourceText​(Dim.SourceInfo sourceInfo)` | Called when the source text for a script has been updated.

    - ### Methods inherited from class javax.swing.JFrame

      `addImpl, createRootPane, frameInit, getAccessibleContext, getContentPane, getDefaultCloseOperation, getGlassPane, getGraphics, getJMenuBar, getLayeredPane, getRootPane, getTransferHandler, isDefaultLookAndFeelDecorated, isRootPaneCheckingEnabled, paramString, processWindowEvent, remove, repaint, setContentPane, setDefaultCloseOperation, setDefaultLookAndFeelDecorated, setGlassPane, setIconImage, setJMenuBar, setLayeredPane, setLayout, setRootPane, setRootPaneCheckingEnabled, setTransferHandler, update`

    - ### Methods inherited from class java.awt.Frame

      `addNotify, getCursorType, getExtendedState, getFrames, getIconImage, getMaximizedBounds, getMenuBar, getState, getTitle, isResizable, isUndecorated, remove, removeNotify, setBackground, setCursor, setExtendedState, setMaximizedBounds, setMenuBar, setOpacity, setResizable, setShape, setState, setTitle, setUndecorated`

    - ### Methods inherited from class java.awt.Window

      `addPropertyChangeListener, addPropertyChangeListener, addWindowFocusListener, addWindowListener, addWindowStateListener, applyResourceBundle, applyResourceBundle, createBufferStrategy, createBufferStrategy, dispose, getBackground, getBufferStrategy, getFocusableWindowState, getFocusCycleRootAncestor, getFocusOwner, getFocusTraversalKeys, getIconImages, getInputContext, getListeners, getLocale, getModalExclusionType, getMostRecentFocusOwner, getOpacity, getOwnedWindows, getOwner, getOwnerlessWindows, getShape, getToolkit, getType, getWarningString, getWindowFocusListeners, getWindowListeners, getWindows, getWindowStateListeners, hide, isActive, isAlwaysOnTop, isAlwaysOnTopSupported, isAutoRequestFocus, isFocusableWindow, isFocusCycleRoot, isFocused, isLocationByPlatform, isOpaque, isShowing, isValidateRoot, pack, paint, postEvent, processEvent, processWindowFocusEvent, processWindowStateEvent, removeWindowFocusListener, removeWindowListener, removeWindowStateListener, reshape, setAlwaysOnTop, setAutoRequestFocus, setBounds, setBounds, setCursor, setFocusableWindowState, setFocusCycleRoot, setIconImages, setLocation, setLocation, setLocationByPlatform, setLocationRelativeTo, setMinimumSize, setModalExclusionType, setSize, setSize, setType, show, toBack, toFront`

    - ### Methods inherited from class java.awt.Container

      `add, add, add, add, add, addContainerListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getAlignmentX, getAlignmentY, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalPolicy, getInsets, getLayout, getMaximumSize, getMinimumSize, getMousePosition, getPreferredSize, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, print, printComponents, processContainerEvent, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusTraversalKeys, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setFont, transferFocusDownCycle, validate, validateTree`

    - ### Methods inherited from class java.awt.Component

      `action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, contains, createImage, createImage, createVolatileImage, createVolatileImage, disable, disableEvents, dispatchEvent, enable, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBaseline, getBaselineResizeBehavior, getBounds, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getFontMetrics, getForeground, getGraphicsConfiguration, getHeight, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocation, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getSize, getTreeLock, getWidth, getX, getY, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isDoubleBuffered, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, prepareImage, prepareImage, printAll, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processKeyEvent, processMouseEvent, processMouseMotionEvent, processMouseWheelEvent, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, requestFocus, requestFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, requestFocusInWindow, resize, resize, revalidate, setComponentOrientation, setDropTarget, setEnabled, setFocusable, setFocusTraversalKeysEnabled, setForeground, setIgnoreRepaint, setLocale, setMaximumSize, setMixingCutoutShape, setName, setPreferredSize, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.awt.MenuContainer

      `getFont, postEvent`

- - ### Constructor Detail

    - #### SwingGui

          public SwingGui​(Dim dim,
                          java.lang.String title)

      Creates a new SwingGui.

  - ### Method Detail

    - #### getMenubar

          public org.mozilla.javascript.tools.debugger.Menubar getMenubar()

      Returns the Menubar of this debugger frame.

    - #### setExitAction

          public void setExitAction​(java.lang.Runnable r)

      Sets the `Runnable` that will be run when the "Exit" menu item is chosen.

    - #### getConsole

          public org.mozilla.javascript.tools.debugger.JSInternalConsole getConsole()

      Returns the debugger console component.

    - #### setVisible

          public void setVisible​(boolean b)

      Sets the visibility of the debugger GUI.
      Overrides:
        `setVisible` in class `java.awt.Window`

    - #### showFileWindow

          protected void showFileWindow​(java.lang.String sourceUrl,
                                        int lineNumber)

      Shows a `FileWindow` for the given source, creating it if it doesn't exist yet. if `lineNumber` is greater than -1, it indicates the line number to select and display.
      Parameters:
        `sourceUrl` - the source URL
        `lineNumber` - the line number to select, or -1

    - #### createFileWindow

          protected void createFileWindow​(Dim.SourceInfo sourceInfo,
                                          int line)

      Creates and shows a new `FileWindow` for the given source.

    - #### updateFileWindow

          protected boolean updateFileWindow​(Dim.SourceInfo sourceInfo)

      Update the source text for `sourceInfo`. This returns true if a `FileWindow` for the given source exists and could be updated. Otherwise, this does nothing and returns false.
      Parameters:
        `sourceInfo` - the source info
      Returns:
        true if a `FileWindow` for the given source exists and could be updated, false otherwise.

    - #### updateSourceText

          public void updateSourceText​(Dim.SourceInfo sourceInfo)

      Called when the source text for a script has been updated.
      Specified by:
        `updateSourceText` in interface `GuiCallback`

    - #### enterInterrupt

          public void enterInterrupt​(Dim.StackFrame lastFrame,
                                     java.lang.String threadTitle,
                                     java.lang.String alertMessage)

      Called when the interrupt loop has been entered.
      Specified by:
        `enterInterrupt` in interface `GuiCallback`

    - #### isGuiEventThread

          public boolean isGuiEventThread()

      Returns whether the current thread is the GUI event thread.
      Specified by:
        `isGuiEventThread` in interface `GuiCallback`

    - #### dispatchNextGuiEvent

          public void dispatchNextGuiEvent()
                                    throws java.lang.InterruptedException

      Processes the next GUI event.
      Specified by:
        `dispatchNextGuiEvent` in interface `GuiCallback`
      Throws:
        `java.lang.InterruptedException`

    - #### actionPerformed

          public void actionPerformed​(java.awt.event.ActionEvent e)

      Performs an action from the menu or toolbar.